//---------------------------------------------------------------------------
//	Import module for external functions for Conditional Filter for VirtualDub
//	Copyright (C) 2001 Dmitri Schamschurko
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//      The author can be contacted at:
//      Dmitri Schamschurko
//      dc1@tcs.inf.tu-dresden.de
//
//      Version 1.0     Oktober 2001
//---------------------------------------------------------------------------

#ifndef f_CONDITIONAL_FUNCTIONS_H
#define f_CONDITIONAL_FUNCTIONS_H

#include <VBitmap.h>

const int ExAvg = 0;
const int ExMin = 1;
const int ExMax = 2;

// ExecuteFunction
//
// Arguments:
// pBitmap	Pointer to the VirtualDub bitmap
// iKind	min/max/avg value of the function
// lStamp	time stamp, can be used to control reexecution
//
// Return value:
// value of the function
typedef long __stdcall (*ExternalFunction) (const VBitmap* pBitmap, int iKind, long lStamp);

typedef struct {
  const char*      name;
  const char*      maker;
  const char*      description;
  ExternalFunction fun;
} ExternalFunctionInfo;

typedef int __stdcall (*TypeGetExtFunctions) (ExternalFunctionInfo** functions);
extern "C" int __stdcall __declspec(dllexport) GetExtFunctions(ExternalFunctionInfo** functions);
#endif
