//---------------------------------------------------------------------------
//	Conditional Filter for VirtualDub - implements simple branching
//	Copyright (C) 2001-2003 Dmitri Schamschurko
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//      The author can be contacted at:
//      Dmitri Schamschurko
//      dc1@tcs.inf.tu-dresden.de
//
//      Version 1.0     Oktober 2001
//      Version 2.0     March 2003
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "f_ConditionCondition.h"

#ifdef _DEBUG
#include "f_ConditionLogic.h"
#include <stdio.h>
#endif

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
// TConditionEditDlg *ConditionEditDlg;
//---------------------------------------------------------------------------
__fastcall TConditionEditDlg::TConditionEditDlg(TComponent* Owner, const char* Text)
        : TForm(Owner)
{
  if (Text)
    FormulaText = Text;
  else
    FormulaText = "";
  Formula = 0;
  ElsePossible = true;
}
//---------------------------------------------------------------------------
void __fastcall TConditionEditDlg::RbClick(TObject *Sender)
{
  IfCondition->Enabled = Sender == RbCondition;
  IfCondition->Color   = (Sender == RbCondition) ? clWindow : clBtnFace;
  if (Sender == RbCondition)
    IfCondition->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TConditionEditDlg::FormActivate(TObject *Sender)
{
//  RbCondition->Checked = true;
//  RbClick(RbCondition);

  if (!ElsePossible)
    RbElse->Enabled = false;

  if (FormulaText != "")
    IfCondition->Lines->Add(FormulaText);

#ifdef ENABLE_RESIZING
  if (BorderStyle == bsDialog)
    BorderStyle = bsSizeable;
#endif
}
//---------------------------------------------------------------------------
extern "C" CFormula* parseFormula(const char* pLine);
void __fastcall TConditionEditDlg::Button1Click(TObject *Sender)
{
  if (RbElse->Checked) return;
  
  Formula = parseFormula(IfCondition->Lines->Text.c_str());
  if (!Formula) {
    ModalResult = mrNone;
    Beep();
    MessageBox(Handle, "Condition cannot be parsed!", "Parse error", MB_OK | MB_ICONERROR);
    IfCondition->SetFocus();
  } else {
    FormulaText = IfCondition->Lines->Text.Trim();
#ifdef _DEBUG
      CMyStrGuard g = Formula->TextOut();
      {
        char tt[2048];
        sprintf(tt, "%s\n\n%s", FormulaText.c_str(), g.c_str());

        MessageBox(0, tt, "verify", MB_OK);
      }
#endif
    if (FormulaText.Length() > 400)
      MessageBox(Handle, "Your condition is longer than 400 chars.\nYou may have problems storing the settings for the batch job!", "Warning", MB_OK | MB_ICONWARNING);
  }
}
//---------------------------------------------------------------------------

