//---------------------------------------------------------------------------
//	Conditional Filter for VirtualDub - implements simple branching
//	Copyright (C) 2001-2003 Dmitri Schamschurko
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//      The author can be contacted at:
//      Dmitri Schamschurko
//      dc1@tcs.inf.tu-dresden.de
//
//      Version 1.0     Oktober 2001
//      Version 2.0     March 2003
//---------------------------------------------------------------------------

#ifndef f_ConditionConfigH
#define f_ConditionConfigH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ActnList.hpp>

#include "f_ConditionIFPWrap.h"
#include "f_ConditionData.h"
//---------------------------------------------------------------------------
class TConditionConfig : public TForm
{
__published:	// IDE-managed Components
        TButton *Button1;
        TButton *Button2;
        TListView *ConditionList;
        TStaticText *Description;
        TButton *PreviewButton;
        TButton *Button3;
        TActionList *ActionList;
        TStaticText *FilterName;
        TButton *Button4;
        TButton *Button5;
        TButton *Button6;
        TButton *Button7;
        TAction *AddCondition;
        TAction *RemoveCondition;
        TAction *UpCondition;
        TAction *DownCondition;
        TAction *EditCondition;
        TAction *ConfigCondition;
        TButton *Button8;
        TButton *Button9;
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall ConditionListClick(TObject *Sender);
        void __fastcall PreviewButtonClick(TObject *Sender);
        void __fastcall AddConditionExecute(TObject *Sender);
        void __fastcall RemoveConditionExecute(TObject *Sender);
        void __fastcall UpConditionExecute(TObject *Sender);
        void __fastcall DownConditionExecute(TObject *Sender);
        void __fastcall EditConditionExecute(TObject *Sender);
        void __fastcall ConfigConditionExecute(TObject *Sender);
        void __fastcall ConditionListDblClick(TObject *Sender);
        void __fastcall ConditionListSelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
private:	// User declarations
        FilterActivation* fa;
        const FilterFunctions *ff;
        ConditionalFilterData *mfd;
//        IFilterPreviewWrap   ifp;
        IFilterPreviewProxy* ifpProxy;
        IFilterPreview*      ifpOriginal;

        TForm* MonitorPreviewDlg;

        void __fastcall UpdateControls();
        void __fastcall RebuildChain();
        void __fastcall UpdateListItem(TListItem* Item);
public:		// User declarations
        __fastcall TConditionConfig(TComponent* Owner, FilterActivation* vfa, const FilterFunctions *vff);
        __fastcall ~TConditionConfig();
        void __fastcall ButtonCallback(bool fNewState);
        void __fastcall SampleCallback(VFBitmap *Bitmap, long lFrame, long lCount);
//        __fastcall TConditionConfig(HWND ParentWindow);
};
//---------------------------------------------------------------------------
//extern PACKAGE TConditionconfig *Conditionconfig;
//---------------------------------------------------------------------------
#endif

