//---------------------------------------------------------------------------
//	Conditional Filter for VirtualDub - implements simple branching
//	Copyright (C) 2001-2003 Dmitri Schamschurko
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//      The author can be contacted at:
//      Dmitri Schamschurko
//      dc1@tcs.inf.tu-dresden.de
//
//      Version 1.0     Oktober 2001
//      Version 2.0     March 2003
//
//      The code in this file uses slightly modified code from the source
//      of VirtualDub v 1.5.1 (http://www.virtualdub.org/)
//      copyrighted by Avery Lee
//
//      Copyright note from that file:
//---------------------------------------------------------------------------
//	VirtualDub - Video processing and capture application
//	Copyright (C) 1998-2001 Avery Lee
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//---------------------------------------------------------------------------

#ifndef f_VD15xProxyH
#define f_VD15xProxyH

#include "f_ConditionData.h"

class CFilterInfo {
  public:
    AnsiString Maker;
    AnsiString Name;
    AnsiString Desc;
    bool HasConfig;
};

class CFilterDefinitionHelper {
  private:
    bool m_VD_15x_Mode;

  public:
    CFilterDefinitionHelper(FilterDefinition* fd);

    FilterDefinition* GetPrev(FilterDefinition* fd);
    FilterDefinition* GetNext(FilterDefinition* fd);

    static FilterDefinition* FindFilter(const char* Name, FilterDefinition* fd);

    CFilterInfo GetInfo(FilterDefinition* fd);
    void Attach(FilterDefinition* fd);
    void Detach(FilterDefinition* fd);
};

class CConditionalDetectDeleted {
  private:
    void* m_DeletedEntries[10];
    int   m_Count;
    int   m_MaxCount;

  public:
    CConditionalDetectDeleted();

    void AddDeleted(void* Ptr);
    bool CheckDeleted(void* Ptr);
};

extern CConditionalDetectDeleted cond_dd;
extern FilterDefinition *fd_conditional;
//---------------------------------------------------------------------------
#endif
